/*
 * 2002-01-31 Modified for SIKIGAMI by AXE,Inc.
 */

#include <config.h>
#ifdef __SIKIGAMI__
#include <gtk/gtk.h>
#include <gnome.h>
#include "tasklist_applet.h"

extern GtkWidget *get_popup_menu (TasklistTask *task);
static GtkWidget *get_popup_listmenu (GList *taskList);
static void add_listmenu_item (gchar *name, GtkWidget *menu, TasklistTask *task);
static void cb_listmenu_position (GtkMenu *menu, gint *x, gint *y,
  gpointer user_data);

extern TasklistConfig Config;
extern TasklistTask *current_task;
extern GtkWidget *area;
extern GtkWidget *applet;

/* Callback for menu positioning */
static void
cb_listmenu_position (GtkMenu *menu, gint *x, gint *y, gpointer user_data)
{
	GtkRequisition mreq;
	gint wx, wy;
	gint screen_width;
	gint screen_height;

	screen_width = gdk_screen_width ();
	screen_height = gdk_screen_height ();

	gtk_widget_get_child_requisition (GTK_WIDGET (menu), &mreq);
	gdk_window_get_origin (area->window, &wx, &wy);

	switch (applet_widget_get_panel_orient (APPLET_WIDGET (applet))) {
	case ORIENT_UP:
		if( wx + mreq.width <= screen_width ){
		    *x = wx;
		}else{
		    if( mreq.width < screen_width )
			*x = screen_width - mreq.width;
		    else
			*x = 0;
		}
		*y = wy - mreq.height;
		break;
	case ORIENT_DOWN:
		if( wx + mreq.width <= screen_width ){
		    *x = wx;
		}else{
		    if( mreq.width < screen_width )
			*x = screen_width - mreq.width;
		    else
			*x = 0;
		}
		*y = wy;
		break;
	case ORIENT_LEFT:
		if( wy + mreq.height <= screen_height ){
		    *y = wy;
		}else{
		    if( mreq.height < screen_height )
			*y = screen_height - mreq.height;
		    else
			*y = 0;
		}
		*x = wx - mreq.width;
		break;
	case ORIENT_RIGHT:
		if( wy + mreq.height <= screen_height ){
		    *y = wy;
		}else{
		    if( mreq.height < screen_height )
			*y = screen_height - mreq.height;
		    else
			*y = 0;
		}
		*x = wx;
		break;
	}

}

/* Callback for menus */
static gboolean
cb_listmenu (GtkWidget *widget, gpointer data)
{
	current_task = (TasklistTask *)data;
/*
	TasklistTask *task = (TasklistTask *)data;

	if (data == NULL) return FALSE;
	gwmh_task_show(task->gwmh_task);
	gwmh_task_focus(task->gwmh_task);
	*/
	return FALSE;
}

/* Open a popup menu with window operations */
void
listmenu_popup (GList *taskList, guint button, guint32 activate_time)
{
	static GtkWidget *menu = NULL;

	if (taskList == NULL) return;
	if (menu)
		gtk_widget_destroy(menu);

	menu = get_popup_listmenu (taskList);

	gtk_signal_connect(GTK_OBJECT(menu), "destroy",
			   GTK_SIGNAL_FUNC(gtk_widget_destroyed),
			   &menu);

	gtk_menu_popup (GTK_MENU (menu), NULL, NULL,
			cb_listmenu_position, NULL,
			button, activate_time);
}

/* Add a menu item to the popup menu */
static void 
add_listmenu_item (gchar *name, GtkWidget *menu, TasklistTask *task)
{
	GtkWidget *menuitem;
	GtkWidget *label;
	GtkWidget *submenu;

	menuitem = gtk_menu_item_new ();
	label = gtk_label_new (name);
	submenu = get_popup_menu(task);
	gtk_misc_set_alignment (GTK_MISC (label), 0.0, 0.5);
	gtk_container_add (GTK_CONTAINER (menuitem), label);
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(menuitem),submenu);
	gtk_signal_connect (GTK_OBJECT (menuitem), "activate",
			    GTK_SIGNAL_FUNC (cb_listmenu), task);
	gtk_widget_show_all (menuitem);
	gtk_menu_append (GTK_MENU (menu), menuitem);

}

/* Create a popup menu */
static GtkWidget 
*get_popup_listmenu (GList *taskList)
{
	GtkWidget *menu;
	GList *cp;
	TasklistTask *ctask;

	menu = gtk_menu_new ();
	gtk_widget_show (menu);

	for (cp = taskList;cp != NULL;cp = cp->next) {
	    ctask = (TasklistTask *)cp->data;
	    add_listmenu_item (ctask->gwmh_task->name, menu, ctask);
	}

	return menu;
}

#endif /* __SIKIGAMI__ */
